various fixes and improvements
[distro-setup] / btrbk-run
index 030107d71834d40589a2951576695f32fec8f6f8..60f065d62e568732cff437d501a1f108d2792f2f 100644 (file)
--- a/btrbk-run
+++ b/btrbk-run
 
 # todo: if we cancel in the middle of a btrfs send, then run again immediately, the received subvolume doesn't get a Received UUID: field, and we won't mount it. Need to figure out a solution that will fix this.
 
-err-bash-trace() {
-  local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
-  local source
-  local extdebug=false
-  if [[ $(shopt -p extdebug) == *-s* ]]; then
-    extdebug=true
-  fi
-  for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
-    argc=${BASH_ARGC[frame]}
-    argc_index+=$argc
-    ((frame < start)) && continue
-    if (( ${#BASH_SOURCE[@]} > 1 )); then
-      source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
-    fi
-    indent=$((frame-start + 1))
-    indent=$((indent < max_indent ? indent : max_indent))
-    printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
-    if $extdebug; then
-      for ((i=argc_index-1; i >= argc_index-argc; i--)); do
-        printf " %s" "${BASH_ARGV[i]}"
-      done
-    fi
-    echo \'
-  done
-  return 0
-}
-err-catch() {
-  set -E; shopt -s extdebug
-  _err-trap() {
-    err=$?
-    exec >&2
-    set +x
-    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
-    err-bash-trace 2
-    set -e # err trap does not work within an error trap
-    "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
-    echo "$0: exiting with code $err"
-    exit $err
-  }
-  trap _err-trap ERR
-  set -o pipefail
-}
-err-catch
-
 
-[[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+[[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
 
+source /usr/local/lib/err
 
 usage() {
   cat <<'EOF'
@@ -87,8 +44,9 @@ rsync-dirs() {
 
 pre="${0##*/}: "
 m() { if $verbose; then printf "$pre%s\n"  "$*"; fi;  "$@"; }
-e() { printf "$pre%s\n"  "$*"; "$@"; }
-die() { printf "$pre%s\n" "$*" >&2;  exit 1; }
+e() { printf "$pre%s\n"  "$*"; }
+die() { printf "$pre%s\n" "$*" >&2; echo "exiting with status 1" >&2; exit 1; }
+mexit() { echo "exiting with status $1"; exit $1; }
 
 # latest $MAIL_HOST
 if [[ -e /b/bash_unpublished/source-state ]]; then
@@ -168,10 +126,11 @@ if [[ -v targets && $source ]]; then
 fi
 
 if $verbose; then
-  e "options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
+  printf "options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
 fi
 ### end options parsing
 
+
 # TODO: i wonder if there should be an option to send to the default
 # targets, plus any given on the command line.
 
@@ -179,11 +138,23 @@ fi
 if [[ ! -v targets && ! $source ]]; then
   if [[ $HOSTNAME != "$MAIL_HOST" ]] && $cron ; then
     echo "MAIL_HOST=$MAIL_HOST, nothing to do"
-    exit 0
+    mexit 0
   fi
+
+  at_work=false
+
   case $HOSTNAME in
-    kw|x2)
-      if ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
+    kw)
+      at_work=true
+      ;;&
+    x2|x3)
+      if ping -q -c1 -w1 hal.office.fsf.org \
+              && ip n show 192.168.0.26 | grep . &>/dev/null; then
+      at_work=true
+      fi
+      ;;&
+    kw|x2|x3)
+      if $at_work && ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
         home=iank.vpn.office.fsf.org
       else
         home=b8.nz
@@ -192,7 +163,7 @@ if [[ ! -v targets && ! $source ]]; then
     kw)
       targets=($home x2)
       ;;
-    x2)
+    x2|x3)
       targets=($home kw)
       ;;
     tp)
@@ -273,7 +244,7 @@ echo "mountpoints: ${mountpoints[*]}"
 if [[ $source ]]; then
   if [[ $(ssh $source systemctl is-active btrbk.service) != inactive ]]; then
     echo "$0: error: cron btrbk is running on source. exiting out of caution"
-    exit 1
+    mexit 1
   fi
 fi
 
@@ -293,7 +264,7 @@ if ! $pull_reexec && [[ $source ]] && $pulla ; then
     e "found newer version on host $source. reexecing"
     install -T $tmpf /usr/local/bin/btrbk-run
     m /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
-    exit
+    mexit 0
   fi
 fi
 
@@ -347,10 +318,10 @@ else
       sshfail+=($h)
     fi
   done
-  if [[ ! $sshable ]] || { ! $cron && [[ $sshfail ]]; }; then
+  if [[ ! ${sshable[@]} ]] || { ! $cron && [[ ${sshfail[@]} ]]; }; then
     die "failed to ssh to hosts: ${sshfail[*]}"
   else
-    if [[ $sshfail ]]; then
+    if [[ ${sshfail[@]} ]]; then
       ret=1
       e "error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
     fi
@@ -430,14 +401,14 @@ done
 
 
 if $conf_only; then
-  exit
+  mexit 0
 fi
 
 
 
 if $dry_run; then
   m btrbk -v -n $cmd_arg
-  exit 0
+  mexit 0
 elif [[ $cmd_arg == archive ]]; then
   if [[ $source ]]; then
     m btrbk $verbose_arg $progress_arg $cmd_arg ssh://$source$vol $vol
@@ -446,7 +417,7 @@ elif [[ $cmd_arg == archive ]]; then
       m btrbk $verbose_arg $progress_arg $cmd_arg $vol ssh://$tg$vol
     done
   fi
-  exit 0
+  mexit 0
 fi
 # -q and just using the syslog option seemed nice,
 # but it doesn't show when a send has a parent and when it doesn't.
@@ -474,7 +445,8 @@ else
   m /a/exe/mount-latest-remote ${targets[@]}
 fi
 
-exit $ret
+e btrbk-run COMPLETED with exit status $ret
+mexit $ret
 
 # todo: move variable data we don't care about backing up
 # to /nocow and symlink it.